
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>使用Java构造高可扩展应用 / iVAN</title>

    <meta name="description" content="使用Java构造高可扩展应用 当 CPU 进入多核时代之后,软件的性能调优就不再是一件简单的事情.没有 并行化的程序在新的硬件上可能会运行得比从前更慢.当 CPU 数目增加的时候 ,芯片制造商为了取得最佳的性能/功耗比,降低 CPU 的运行频率是一件非常明 智的事情.相比 C/C++ 程序员而言 , 利用 Java 编写多线程应用已经简单了很 多.然而,多线程程序想要达到高性能仍然不是一件容易的事情.对于软件开发 人员而言, 如果在测试时发现并行程序并不比串行程序快,那不是一件值得惊 讶的事情,毕竟,在多核时代之前, 受到广">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">使用Java构造高可扩展应用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>当 CPU 进入多核时代之后，软件的性能调优就不再是一件简单的事情。没有 并行化的程序在新的硬件上可能会运行得比从前更慢。当 CPU 数目增加的时候 ，芯片制造商为了取得最佳的性能/功耗比，降低 CPU 的运行频率是一件非常明 智的事情。相比 C/C++ 程序员而言 , 利用 Java 编写多线程应用已经简单了很 多。然而，多线程程序想要达到高性能仍然不是一件容易的事情。对于软件开发 人员而言， 如果在测试时发现并行程序并不比串行程序快，那不是一件值得惊 讶的事情，毕竟，在多核时代之前， 受到广泛认可的并行软件开发准则通常过 于简单和武断。</p>
<p>在本文中，我们将介绍提高 Java 多线程应用性能的一般步骤。 通过运用本 文提供的一些简单规则，我们就能获得具有高性能的可扩展的应用程序。</p>
<p>为什么性能没有增长？</p>
<p>多核能带来性能的大幅增长，这很容易通过简单的一些测试来观察到。如果 我们写一个多线程程序，并在每个线程中对一个本地变量进行累加，我们可以很 容易的看到多核和并行带来的成倍的性能提升。这非常容易做到，不是吗？在 参考资源 里我们给出了一个例子。然而，与我们的测试相反，我们很少在实际 软件应用中看到这样完美的可扩展性。阻碍我们获得完美的可扩展性有两方面的 因素存在。首先，我们面临着理论上的限制，其次软件开发过程中也经常出现实 现上的问题。让我们看看 图 1 中的三条性能曲线：</p>
<p>图 1. 性能曲线</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g0Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMjE0NTExMjNhLTAucG5n.jpg"></p>
<p>作为追求完美的软件工程师，我们希望看到随着线程数目的增长程序的性能 获得线性的增长，也就是图 1 中的蓝色直线。而我们最不希望看到的是绿色的 曲线，不管投入多少新的 CPU，性能也没有丝毫增长。（随着 CPU 增长而性能 下降的曲线在实际项目中也存在）。而图中的红色线条则说明通常的 90-10 法 则并不适用于可扩展性方面。假设程序中有 10% 的计算只能串行进行，那么其 扩展性曲线如红线所示。由图可见，当 90% 的代码可以完美的并行时，在 10 个 CPU 存在的情况下，我们也只能获得大约 5 倍的性能。如果任务中具有无法 并行的部分，那么在现实世界，我们的性能曲线大致上会位于图 1 中的灰色区 域。</p>
<p>在这篇文章中，我们不会试图挑战理论极限。我们希望能解释一个 Java 程 序员如何能够尽可能的接近极限，这已经不是一个容易的任务。</p>
<p>是什么造成了糟糕的可扩展性？</p>
<p>可扩展性糟糕的原因有很多，其中最为显著的是锁的滥用。这没有办法，我 们就是这样被教育的：“想要多线程安全吗？那就加一个锁吧”。想想 Python 中臭名昭著的 Global Intepreter Lock，还有 Java 中的 Collections.synchronizedXXXX() 系列方法，跟随巨人的做法有什么不好吗？ 是的，用锁来保护关键区域非常方便，也较容易保证正确性，然而锁也意味着只 有一个进程能进入关键区域，而其他的进程都在等待！如果观察到 CPU 空闲而 软件执行缓慢，那么检察一下锁的使用是一个明智的做法。</p>
<p>对于 Java 程序而言，Performance Inspector 中的 Java Lock Monitor 是 一个不错的开源工具。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-08 01:05:07</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e4%b8%80%e4%b8%aa/" title="一个">一个</a>, <a href="https://www.iamivan.net/tag/%e7%a8%8b%e5%ba%8f/" title="程序">程序</a>, <a href="https://www.iamivan.net/tag/%e6%80%a7%e8%83%bd/" title="性能">性能</a>, <a href="https://www.iamivan.net/tag/%e6%9b%b2%e7%ba%bf/" title="曲线">曲线</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e7%ba%bf%e7%a8%8b/" title="多线程">多线程</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e6%a0%b8/" title="多核">多核</a>, <a href="https://www.iamivan.net/tag/cpu-%e5%a4%9a%e6%a0%b8%e5%88%86%e9%85%8d-%e6%97%b6%e5%ba%8f/" title="cpu 多核分配 时序">cpu 多核分配 时序</a>, <a href="https://www.iamivan.net/tag/%e7%ae%80%e5%8d%95%e6%80%a7%e8%83%bd/" title="简单性能">简单性能</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>使用Java构造高可扩展应用的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze670xb.html" rel="bookmark">使用Docker、Registrator、Consul、Consul Template和Nginx实现高可扩展的Web框架</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是使用Docker.Registrator.Consul.Consul Template和Nginx实现高可扩展的Web框架,[编者的话]Consul是一个支持多数据中心分布式高可用的服务发现和配置共享的服务软件,由 HashiCorp 公司用Go语言开发,基于 Mozilla Public License 2.0 的协议开源.本文介绍了如何使用Consul将多个Docker容器组合起来,以提供一个高可扩展的Web服务. 当你开始将容器拼装起来构建你的系统的时候,你会发现Docker非常			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXq0alz.html" rel="bookmark">有人说C&num;的性能没有java那么高，是吗？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 有人说C#的性能没有java那么高,是吗? 解决方案 解决方案二:这种帖子哥已经懒得回了.解决方案三:软件的好坏与程序员有关,与语言无关解决方案四:说的很对,还是跟人有关解决方案五:引用1楼xinyaping的回复: 这种帖子哥已经懒得回了. 解决方案六: 解决方案七:我都想爆粗口了!FUCK解决方案八:一个应用不光与开发语言有关系,与数据库.操作系统.硬件有很大关系......解决方案九: 解决方案十:引用1楼xinyaping的回复: 这种帖子哥已经懒得回了. 那你这是在干什么捏?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZgokOb.html" rel="bookmark">Help！！关于java构造块问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Help!!关于java构造块问题 public class Test{ public int i=print(&quot;why&quot;); { print(&quot;构造块&quot;); } private static int print(String str){ System.out.println(str); } } 为什么每次实例化对象时,调用构造块的同时也会调用构造块前面的那个赋值语句? 解决方案 首先 private static int print(String str			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqLo7p.html" rel="bookmark">使用Java构造和解析Json数据的两种方法&lpar;详解二&rpar;&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JSON(JavaScript Object Notation) 是一种轻量级的数据交换格式,采用完全独立于语言的文本格式,是理想的数据交换格式.同时,JSON是 JavaScript 原生格式,这意味着在 JavaScript 中处理 JSON数据不须要任何特殊的 API 或工具包. 在www.json.org上公布了很多JAVA下的json构造和解析工具,其中org.json和json-lib比较简单,两者使用上差不多但还是有些区别.下面接着介绍用org.json构造和解析Json数据的方法			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Ygm6p.html" rel="bookmark">java成本高&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 公司搞php的占大部分,只有少数是搞java的,而且只是作后台数据处理的时候有到java.之前听过同事说java开发成本高,网上也有相类似的说法,我没搞明白,成本具体是指哪些?--开发难度大?--维护成本高?--系统搭建成本高?还是别的? 解决方案 首先我们看成本由哪些部分组成1.开发成本 2.服务器成本3.运维成本但是成本的高低不好说,因为和项目的规模很有关系http://www.infoq.com/cn/news/2011/07/java-taobao看一下上面的这篇文章,淘宝为什			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mrdj1mz.html" rel="bookmark">Spark中如何用Java构造Graph</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Spark中如何将JavaRDD转化为VertexRDD.EdgeRDD,如何用Java构造Graph? 解决方案 解决方案二:graphX貌似目前没有javaAPI			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2gm5p.html" rel="bookmark">使用Java构建高伸缩性组件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着多核处理器成为主流,应用开发人员对于如何编写高伸缩性的应用以利用底层硬 件的优势这个问题面临巨大的压力.此外,遗留系统不得不移植到新的架构上.保证应用 伸缩性的一种有效方式是使用高伸缩性组件构建应用.举例来说,在各种应用中, java.util.concurrent.ConcurrentHashMap可以替代同步的HashTable,使应用伸缩性更 好.因此,向应用直接提供一套高伸缩性构造块以引入并行是非常有用的. 我们创建了一套高伸缩性并发Java组件作为Amin库项目的一部分.在本文中,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLOXevM.html" rel="bookmark">用Java构造自己的媒体播放器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概述 首先我们来看看构造这个媒体播放器要达到什么样的目标,确定了目标也就确定了代码量和程序的复杂程度.本文的媒体播放器要达到如下目标: 媒体播放器是一个菜单驱动的简单AWT应用. 媒体播放器包含一个&quot;文件&quot;菜单,文件菜单包含三个菜单项: &quot;打开&quot;,用来打开媒体文件. &quot;循环&quot;,是播放一次(默认),还是重复播放. &quot;退出&quot;,退出程序. 媒体播放器可以在多种平台上运行. 媒体播放器的核心功能通过JMF(Java Media F			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXB5m4b.html" rel="bookmark">什么是Java &quest;Java详解之扩展和相关架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				扩展和与Java程序设计语言紧密相关的架构(按字母排序). Groovy ,一种用纯Java实现的脚本语言,Python的强有力竞争者 JAIN (Java API for Integrated Networks)Java综合网络应用程序开发接口 JAI,(Java Advanced Imaging)Java进阶图像 JAXP, (Java API for XML Processing) Java XML 处理 API Java EE(原名J2EE),Java平台企业版 Java ME(原名J2			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ6arM.html" rel="bookmark" class="title">CSS中的相对定位与绝对定位</a>
					<div>
						css 在CSS中有这样的一个指令:(position) 在DW中文版中翻译为&quot;定位&quot;,常用的属性有relative(相对)与 absolute(绝对). 有很多朋友对这条指令的用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY20aep.html" rel="bookmark" class="title">TD-SCDMA移动终端测试研究</a>
					<div>
						摘要: 基于CDMA2000 1X技术的第三代移动通信系统的发展战略,类别CDMA 1X在中国的移动终端一致性测试,提出TD-SCDMA移动终端的测试是非常必要的.本文除了着重介绍一致性测试原理,一致 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2o6Jb.html" rel="bookmark" class="title">精通Hibernate之映射继承关系三</a>
					<div>
						&lt;hibernate-mapping &gt; &lt;class name=&quot;mypack.SalariedEmployee&quot; table=&quot;SALARIED_E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXB83Ab.html" rel="bookmark" class="title">后期PS打造忧郁颓废的非主流情感写真场景教程</a>
					<div>
						在动画制作中常以不同的场景来表达人物情感.婚纱写真摄影也经常利用后期PS技术置换不同背景道具达到同样的效果.本期介绍的内容是通过后期添加场景元素 来清晰地表达人物主体忧郁的内在情感. 关键:后期加入蝴 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxB92b.html" rel="bookmark" class="title">搜狗五笔输入法输入窗口怎么样</a>
					<div>
						  状态栏: 搜狗输入法的输入窗口: 搜狗输入法的输入窗口很简洁,上面的一排是你所输入的五笔编码,下一排就是候选字,输入所需的候选字对应的数字,即可输入该词.第一个词默认是红色的,直接敲下空格即可输入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6eY2Nb.html" rel="bookmark" class="title">固态硬盘要开启AHCI电脑提示找不到硬盘怎么办</a>
					<div>
						刚刚装的机器,具体配置是i7 2600K/ 技嘉z68XP-UD3P-rev1.0 主板/ 技嘉560TiOC 版显卡/ 饥饿鲨(OCZ)Agility3 60G 2.5 英寸SATA-3 固态硬盘/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwLPPvb.html" rel="bookmark" class="title">铭斯自动重启工具怎么使用？</a>
					<div>
						  铭斯自动重启工具怎么使用? 1.启动:运行本程序,设置定时自动重启的时间,点击&quot;启动服务&quot;即可. 2.停止:运行本程序,点击&quot;停止服务&quot;即可. 3.设置时间 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWX6Dqp.html" rel="bookmark" class="title">360免费WiFi什么是免费时长？如何使用？</a>
					<div>
						  用户可将金币自由兑换为免费上网时长,该时长当月有效,用户可在有效期内免费接入CMCC.ChinaUnicom.ChinaNet等热点信号					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYq0ZM.html" rel="bookmark" class="title">初试Lua</a>
					<div>
						听说Lua脚本语言可以很好地嵌入到C与C++程序中,今天我小试了一下. 首先是下载.从Lua官网上下载源码到本地.http://www.lua.org/download.html 最好去下载最近的源码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze78LNM.html" rel="bookmark" class="title">【资料整理】VC工程中的各种文件</a>
					<div>
						[.ncb] No Compile Browser,无编译浏览文件. 是VC++开发环境创建的跟踪文件,其中存放了供ClassView.WizardBar和Component Gallery使用的信息 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlnRkb.html" rel="bookmark" class="title">【转载】VS2010 C&plus;&plus; Debug 出现&OpenCurlyDoubleQuote;Cannot find or open the&period;&period;&period;</a>
					<div>
						使用 VS2010 在 Debug 模式下调试程序的时候经常会遇到如下的输出信息: ? 1 2 3 4 5 6 7 8 &quot;abc.exe&quot;: 已加载&quot;C:\WINDOWS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NW9Wz.html" rel="bookmark" class="title">调用函数-C&plus;&plus;&sol;C&num;的函数内嵌问题</a>
					<div>
						问题描述 C++/C#的函数内嵌问题 int a(){ int c=1; int d=2; int e=3; return c+d+e;}int b(){ int c=a(); int d=a();  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkdZ4b.html" rel="bookmark" class="title">你的设计应该「所见即所得」</a>
					<div>
						本文讲的是你的设计应该「所见即所得」, 几年前的一个夏天,我有机会住在旧金山里同一栋楼不同单元的两个 Loft 公寓中. 由于这是同一栋楼,所以你可能会想这两个单元应该是相似的.的确,它们都有1000 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2P1Bop.html" rel="bookmark" class="title">lvm管理：扩展lv、删除pv、lv等</a>
					<div>
						从卷组VG里扩展lv.删除pv,并删除物理卷PV 一.扩展LV.缩小LV 1.卸载LV 命令:umount  &quot;挂载目录&quot; 2.扩展LV 命令:lvextend -L +500m  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1l0J8b.html" rel="bookmark" class="title">jQuery-可折叠的模式</a>
					<div>
						jQuery: &lt;script src=&quot;Scripts/jquery-1.4.1.js&quot; type=&quot;text/javascript&quot;&gt;&lt;/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPddrp.html" rel="bookmark" class="title">翻墙软件-火狐浏览器安装百度云插件</a>
					<div>
						问题描述 火狐浏览器安装百度云插件 火狐浏览器安卓手机,如何安装插件,要积分才可以下载使用?如何安装百度云加xpi,下载下来都是crx文件,打不开!安装不了xpi 解决方案 linux下火狐浏览器fl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrB15M.html" rel="bookmark" class="title">javascript弹出模式窗体</a>
					<div>
						问题描述 javascript弹出模式窗体 用window.showModalDialog()弹出模式窗体怎样写只允许有一个,比如: 我现在是这样的,我们一个电话系统,别人打电话来就弹出窗体,现在第一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lerjb.html" rel="bookmark" class="title">菜鸟 求解答-html中一个标签如果有两个类属性，里面有些属性冲突，那属性该遵循哪个的</a>
					<div>
						问题描述 html中一个标签如果有两个类属性,里面有些属性冲突,那属性该遵循哪个的 html中一个标签如果有两个类属性,里面有些属性冲突,那属性该遵循哪个的 解决方案 这个是根据你css样式的前后顺序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AJo9z.html" rel="bookmark" class="title">mysql-MySQL嵌套表头数据存储问题</a>
					<div>
						问题描述 MySQL嵌套表头数据存储问题 如图所示,这样的表格在MySQL数据库中应该如何建立表 解决方案 直接把基本信息四个字无视,一共8个字段,即可. 解决方案二: 建立两张表,第一章表,序号,姓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1rAX8p.html" rel="bookmark" class="title">PS抠出自行车的实用抠图教程</a>
					<div>
						抠图只有适应的方法,没有最好的方法,以本图为例,我们可以只用一步就抠出自行车. 原图 效果 方法步骤: 01.准备工作:打开图片,ctrl+j得到图层1,点击红圈处新建图层2 放于图层1和 背景 层之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKJLKz.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;女主播&rdquo;裸聊非法获利700万余元</a>
					<div>
						近年来,随着网民队伍的不断壮大,网络诈骗变得司空见惯.然而,随着网民防诈骗意识的提高,一些新诈骗手段开始层出不穷.昨日,南京市中级人民法院公布一起网络诈骗典型案例,来自广东.浙江.陕西等地的6人团伙建 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR3y0p.html" rel="bookmark" class="title">中广传播CMMB手持电视将于5月1日正式商用</a>
					<div>
						CMMB睛彩导航和睛彩财经业务属于数据广播业务 腾讯科技讯(郭晓峰)4月18日消息,中广传播今天在深圳宣布,睛彩财经.睛彩导航两项数据广播业务自5月1日起正式商用,睛彩导航和睛彩财经的商用将采用套餐形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLaaaM.html" rel="bookmark" class="title">甲骨文发布新SPARC服务器 全球最快CPU助阵</a>
					<div>
						[天极网服务器频道3月27日消息]甲骨文公司今天宣布推出运行Oracle Solaris的全新SPARC T5和M5服务器,作为对其中.高端SPARC服务器产品线的全面升级.新推出的Oracle SP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLEqDM.html" rel="bookmark" class="title">中国最具投资价值企业50强榜单揭晓</a>
					<div>
						本报讯7月10日,清科&quot;2009中国最具投资价值企业50强&quot;揭开神秘面纱,本届50强企业前三甲分别花落福建匹克集团有限公司.惠州雷士光电科技有限公司.中航惠腾风电设备股份有限公司. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRlD0p.html" rel="bookmark" class="title">移动互联网使用率每年翻一番</a>
					<div>
						[TechWeb报道]2月7日消息,据国外媒体报道,数据分析机构StatCounter最新报告称,自2009年以来,移动互联网使用率每年翻一番. StatCounter数据显示,2012年1月移动互联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0N61Dz.html" rel="bookmark" class="title">JavaScript将Web页面内容导出到Word及Excel的方法&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了JavaScript将Web页面内容导出到Word及Excel的方法.分享给大家供大家参考.具体实现方法如下: &lt;HTML&gt; &lt;HEAD&gt; &lt;title&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW6jkz.html" rel="bookmark" class="title">学习C&num;数百个命名空间的几千个类还有方法如何记忆？</a>
					<div>
						问题描述 大家谈谈学习C#时这么多的属性方法是如何记忆的?要是记忆相同数量的英语单词,英语口语绝对没问题了.真的需要一个一个记忆吗? 解决方案 解决方案二:1)熟练:2)常规/习惯,必须Visible ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlWlPYb.html" rel="bookmark" class="title">重庆电信明年宽带全面提速</a>
					<div>
						本报讯 日前,中国电信重庆公司制定了&quot;2011年主城宽带发展规划&quot;,提出明年主城区宽带市场份额目标从目前的63%提升到70%以上,用户带宽占比目标实现2M以上用户达80%,4M以上 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQay0wb.html" rel="bookmark" class="title">《移动App测试实战》&mdash;&mdash;第1章  产品功能测试概述</a>
					<div>
						第1章 产品功能测试概述人们在一起可以做出单独一个人所不能做出的事业.-韦伯斯特 对于用户而言,移动互联网产品是一个可以在移动设备上安装的App,或者一个可以为移动设备定制的页面,看起来比较简单,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQaZ38b.html" rel="bookmark" class="title">CV微晚报：史玉柱一条微博赚3亿 张兰杯葛鼎晖</a>
					<div>
						点击此处:@ChinaVenture投中集团新浪微博 点击此处:@ChinaVenture投中集团搜狐微博 点击此处:@ChinaVenture投中集团腾讯微博 [公司] 1.俏江南张兰:引进鼎晖是最 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
